function [ det ] = determinant( A )
% Vpoet determinantu matice pomoc LU rozkladu s stenou pivotac
%
%   [ det ] = determinant( A )
%   Vstup:  A ... regulrn matice n x n
%   Vstup: det ... determinant matice A
%
%   Datum posledn pravy: 23.7.2015, KF

try
[A, p] = luRozklad(A);
catch ME
    if (strcmp(ME.identifier, 'LU:singularniMatice'))
        det = 0; % Matice je singulrn
        return
    else
        rethrow(ME)
    end
end
% Znamnko permutace
[n, ~] = size(A);
sign = 1;
for i = 1 : n - 1
    for j = i + 1 : n
        if p(i) > p(j)
            sign = -sign;
        end
    end
end
det = sign * prod(diag(A));
end

