function [ U ] = invU( U )
% Vpoet inverze horn trojhelnkov matice
%
%   [ X ] = invU( U )
%   Vstup:  U ... horn trojhelnkov matice n x n
%   Vstup: X ... inverzn matice U^-1
%
%   Datum posledn pravy: 26.8.2015, KF

[n, ~] = size(U);
for j = 1 : n
    U(j, j) = 1 / U(j, j);
    U(1 : j - 1, j) = U(1 : j - 1, 1 : j - 1) * U(1 : j - 1, j);
    U(1 : j - 1, j) = -U(j, j) * U(1 : j - 1, j);
end
end

