function [ X ] = inverzeA( A )
% Vpoet inverzn matice pomoc LU rozkladu s stenou pivotac
% Inverze X je potna po sloupcch postupnm eenm soustav 
% A * X(:, j) = I(:, j)
%
%   [ X ] = inverzeA( A )
%   Vstup:  A ... regulrn matice n x n
%   Vstup: X ... inverzn matice A^-1
%
%   Datum posledn pravy: 16.8.2015, KF

[A, p] = luRozklad(A);
[n, ~] = size(A);
X = eye(n);
X = X(p, :);
for j = 1 : n  
    % Vpoet j-tho sloupce
    for k = 2 : n
        X(k, j) = X(k, j) - A(k, 1 : k - 1) * X(1 : k - 1, j);
    end
    X(n, j) = X(n, j) / A(n, n);
    for k = n - 1 : -1 : 1
        X(k, j) = (X(k, j) - A(k, k + 1 : n) * X(k + 1 : n, j)) / A(k, k);
    end
end
end

