function [ B, C ] = hodRozklad( A, tol )
% Hodnostn rozklad matice
%
%   [ B, C ] = hodRozklad( A, tol )
%   Vstup:  A ... matice m x n, A ~= 0
%           tol ... tolerance pro rozpoznn nuly
%   Vstup: B ... matice m x r
%           C ... matice r x n
%
%   Datum posledn pravy: 8.8.2015, KF

[~, n] = size(A);
% Vpoet redukovanho odstupovanho tvaru
[R, baz] = rrefTvar(A, tol);
% Hodnost matice A
r = length(baz);
if r == 0
    error('Zadan matice je nulov.')
end
% Matice B je tvoena bzovmi sloupci matice A
B = A(:, baz);
% Matice C odpovd prvnm r dkm matice R
C = R(1 : r, 1 : n);
end

