% Rozpoznvn tv metodou "eigenfaces" 
% dle Turk, Pentland: Eigenfaces for recognition

% Fotografie pouit pro experimenty pochzej z databze ORL, 
% kad obraz m rozmry 112x92 a je uloen ve formtu pgm, 
% obrazy trninkov mnoiny jsou umstny ve sloce faces\training\, 
% obrazy testovac mnoiny jsou umstny ve sloce faces\test\, 
% obrazy jsou pojmenovny x.pgm, kde x pedstavuje slo jedince

n = 10304; % 112 * 92
m = 39; % Poet obraz v trninkov mnoin
% Naten obraz trninkov mnoiny
X = zeros(n, m);
for i = 1 : m
    Xi = imread(strcat('faces\training\', int2str(i), '.pgm'));
    Xi = double(Xi) ./ double(intmax(class(Xi)));
    X(:, i) = reshape(Xi, [n 1]);
end
% Vpoet prmrnho obrazu trninkov mnoiny
prumer = mean(X, 2);
% Odeten prmru od vech obraz
for i = 1 : m
    X(:, i) = X(:, i) - prumer;
end
% SVD rozklad matice obraz
[U, S, ~] = svd(X, 'econ');
% Uren potu p vlastnch sel kovariann matice, kter odpovdaj 
% 90 % variability pvodnch dat 
vlCis = diag(S) .^ 2;
suma = sum(vlCis);
ksuma = 0;
i = 1;
while (ksuma / suma) < 0.9
    ksuma = ksuma + vlCis(i);
    i = i + 1;
end
p = i;
% Projekce obraz trninkov mnoiny do prostoru tv, jeho bzi tvo 
% prvnch p vlastnch vektor kovariann matice
% (vpoet vektor Omega)
U = U(:, 1 : p);
X = U' * X;

t = 41; % poet obraz v testovac mnoin
% Naten obraz testovac mnoiny
Y = zeros(n, t);
for i = 1 : t
    Yi = imread(strcat('faces\test\', int2str(i), '.pgm'));
    Yi = double(Yi) ./ double(intmax(class(Yi)));
    Y(:, i) = reshape(Yi, [n 1]);
end
vysledky = zeros(3, t);
% Pro kad obraz testovac mnoiny
for i = 1 : t
    Y(:, i) = Y(:, i) - prumer; % Odeten prmru
    Yomega = U' * Y(:, i); % Vpoet vektoru Omega
    % Nalezen nejbliho obrazu trninkov mnoiny
    e = zeros(1, m);
    for j = 1 : m
        e(j) = norm(Yomega - X(:, j));
    end
    [emin, jedinec] = min(e);    
    d = norm(Y(:, i) - U * Yomega); % Vzdlenost od prostoru tv
    vysledky(:, i) = [jedinec; emin; d];
end

