% Rozpoznvn tv metodou "eigenfaces" s vyuitm FSVDR reprezentace
% tv
% dle Liu, Chen, Tan: Fractional order singular value decomposition 
% representation for face recognition

% Fotografie pouit pro experimenty pochzej z databze Yale, 
% kad obraz m rozmry 143x100 a je uloen ve formtu pgm, 
% obrazy trninkov mnoiny jsou umstny ve sloce faces2\training\, 
% obrazy testovac mnoiny jsou umstny ve sloce faces2\test\, 
% obrazy jsou pojmenovny x.pgm, kde x pedstavuje slo jedince

alpha = 0.1; % Parametr pro FSVDR
n = 14300; % 143 * 100
m = 15;
X = zeros(n, m);
for i = 1 : m
    Xi = imread(strcat('faces2\training\', int2str(i), '.pgm'));
    Xi = double(Xi) ./ double(intmax(class(Xi)));
    % Nahrazen natenho obrazu z trninkov mnoiny jeho FSVDR
    % reprezentac
    [Ui, Si, Vi] = svd(Xi, 'econ');
    Xi = Ui * Si^alpha * Vi';
    X(:, i) = reshape(Xi, [n 1]);
end
prumer = mean(X, 2);
for i = 1 : m
    X(:, i) = X(:, i) - prumer;
end
[U, S, ~] = svd(X, 'econ');
vlCis = diag(S) .^ 2;
suma = sum(vlCis);
ksuma = 0;
i = 1;
while (ksuma / suma) < 0.9
    ksuma = ksuma + vlCis(i);
    i = i + 1;
end
p = i;
U = U(:, 1 : p);
X = U' * X;

t = 15;
Y = zeros(n, t);
for i = 1 : t
    Yi = imread(strcat('faces2\test\', int2str(i), '.pgm'));
    Yi = double(Yi) ./ double(intmax(class(Yi)));
    % Nahrazen natenho obrazu z testovac mnoiny jeho FSVDR
    % reprezentac
    [Ui, Si, Vi] = svd(Yi, 'econ');
    Yi = Ui * Si^alpha * Vi';
    Y(:, i) = reshape(Yi, [n 1]);
end
vysledky = zeros(3, t);
for i = 1 : t
    Y(:, i) = Y(:, i) - prumer;
    Yomega = U' * Y(:, i);
    e = zeros(1, m);
    for j = 1 : m
        e(j) = norm(Yomega - X(:, j));
    end
    [emin, jedinec] = min(e);
    d = norm(Y(:, i) - U * Yomega);
    vysledky(:, i) = [jedinec; emin; d];
end

