function [ A ] = pinvSvd( A, tol )
% Moore-Penroseova inverze za vyuit SVD rozkladu
%
%   [ X ] = pinvSvd( A, tol )
%   Vstup:  A ... matice m x n
%           tol ... tolerance pro rozpoznn nulovch singulrnch sel
%   Vstup: X ... Moore-Penroseova inverze matice A
%
%   Datum posledn pravy: 1.11.2015, KF

[U, S, V] = svd(A, 'econ'); % Redukovan SVD rozklad
s = diag(S);
r = sum(s > tol); % Hodnost matice S resp. A vzhledem k zadan toleranci
s = 1 ./ s(1 : r);
A = V(:, 1 : r) * diag(s) * U(:, 1 : r)';
end

