% TSVD regularizace a rekonstrukce rozmazanho obrazu

% Pi tvorb skriptu bylo erpno z knihy Hansen, Nagy, O'Leary:  
% Deblurring images, odkud byly pevzaty funkce psfGauss a kronDecomp

% Naten obrazu (ideln nerozmazan obraz)
X = imread('HK.jpg');
% Pevod na odstny edi
X = 0.2989 * X(:, :, 1) + 0.5870 * X(:, :, 2) + 0.1140 * X(:, :, 3);
% Pevod na hodnoty typu double <0; 1>
X = double(X) ./ double(intmax(class(X)));
% Zobrazen pvodnho nerozmazanho obrazu
figure
imagesc(X, [0 1])
axis image
axis off
colormap(gray)
    
% Vytvoen PSF pro rozmazn funkc Gaussova normlnho rozdlen 
% (smrodatn odchylka = 7)
[PSF, stred] = psfGauss(size(X), 7);
% Vpoet matic AR, AC Kronekerova souinu pi reflexivnch hraninch 
% podmnkch 
[AR, AC] = kronDecomp(PSF, stred, 'reflexive');
% Konstrukce rozmazanho obrazu
B = AC * X * AR';
% Pidn aditivnho umu (Gaussv bl um)
% (norm(B_NOISE, 'fro') / norm(B_EXACT, 'fro') = 1e-4)
E = randn(size(B));
E = E / norm(E, 'fro');
B = B + 1e-4 * norm(B, 'fro') * E;
figure
imagesc(B, [0 1])
axis image
axis off
colormap(gray)
    
% Vpoet naivnho een
Xn = pinv(AC) * B * pinv(AR)';
figure
imagesc(Xn, [0 1])
axis image
axis off
colormap(gray)
    
% TSVD regularizace a vsledn een 
% (regularizan parametr k odpovd potu singulrnch sel matice A 
% vtch ne tolerance tol)
[UR, SR, VR] = svd(AR, 'econ');
[UC, SC, VC] = svd(AC, 'econ');
S = diag(SC) * diag(SR)';
tol = 2.8e-4; % Tolerance odpovdajc vhodnmu een (ureno experimentln)
Phi = (abs(S) >= tol); % k = sum(Phi(:));
idx = (S ~= 0);
s = zeros(size(Phi));
s(idx) = Phi(idx) ./ S(idx);
Xf = VC * ((UC' * B * UR) .* s) * VR';
figure
imagesc(Xf, [0 1])
axis image
axis off
colormap(gray)

tol = 5e-5; % Podregularizovan een
Phi = (abs(S) >= tol);
idx = (S ~= 0);
s = zeros(size(Phi));
s(idx) = Phi(idx) ./ S(idx);
Xf = VC * ((UC' * B * UR) .* s) * VR';
figure
imagesc(Xf, [0 1])
axis image
axis off
colormap(gray)

tol = 1e-1; % Peregularizovan een
Phi = (abs(S) >= tol);
idx = (S ~= 0);
s = zeros(size(Phi));
s(idx) = Phi(idx) ./ S(idx);
Xf = VC * ((UC' * B * UR) .* s) * VR';
figure
imagesc(Xf, [0 1])
axis image
axis off
colormap(gray)

